package  
{
	import net.hires.debug.Stats;

	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.getDefinitionByName;

	/**
	 * @author Nicolas Schudel
	 */
	public class PerformanceTestFLV_Backwards extends Sprite 
	{
		private const TOTAL_ROWS:int = 2;
		private const TOTAL_COLUMNS:int = 2;
		private var _clips:Array = [];
		private var _frame:int;

		public function PerformanceTestFLV_Backwards()
		{
			stage.addEventListener(MouseEvent.CLICK, startTest);
		}

		private function startTest(event:Event):void
		{
			stage.removeEventListener(MouseEvent.CLICK, startTest);
			
			var ref:Class = getDefinitionByName("Sequence") as Class;
			var posY:Number = 0, posX:Number = 0;
			var rows:int = TOTAL_ROWS;
			while (rows--) 
			{
				var columns:int = TOTAL_COLUMNS;
				posX = 0;
				
				while (columns--) 
				{
					var mc:MovieClip = new ref() as MovieClip;
					addChild(mc);
					mc.stop();
					// did not see a difference in performance by enabling this
					// mc.cacheAsBitmap = true;
					mc.x = posX;
					mc.y = posY;
					// update column position
					posX += stage.stageWidth / TOTAL_COLUMNS;
					
					_clips.push(mc);
				}
				// update row position
				posY += stage.stageHeight / TOTAL_ROWS;
			}
			
			var stats:Stats = new Stats();
			stats.y = stats.x = 40;
			addChildAt(stats, TOTAL_ROWS * TOTAL_COLUMNS);
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			for each (var mc : MovieClip in _clips) 
			{
				_frame = mc.currentFrame - 1;
				if (_frame < 1) _frame = mc.totalFrames;
				mc.gotoAndStop(_frame);
			}
		}
	}
}
